// This file is copyright 2000-2001 xmedia srl
// http://www.xmedia.net/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include "defines.h"

#define DEBUG


int main(int argc, char *argv[]) {
	int retval;

	char *user, *domain, *pass;
	char *dir;
	char comment[sizeof(COMMENTSTR) + DOMAINSIZE + 1];

	if(argc < 4) {
		fprintf(stderr, "Usage: %s <user> <domain> <pass>\n", argv[0]);
		exit(EXIT_FAILURE);
	}

	user = argv[1];
	domain = argv[2];
	pass = argv[3];

	if(! checkusername(user)) {
		fprintf(stderr, "Invalid user name %s\n", user);
		exit(EXIT_FAILURE);
	}

	if(! checkdomainname(domain)) {
		printf("Invalid domain name %s\n", domain);
		exit(EXIT_FAILURE);
	}

	dir = constructhomedir(domain);
	snprintf(comment, sizeof(comment) - 1, "%s%s\0", COMMENTSTR, domain);

	retval = execle(USERADD, USERADD, "-c", comment, "-d", dir, "-s", "/bin/false", "-M", "-p", pass, user, NULL, NULL);

	return retval;
}
