// This file is copyright 2000-2001 xmedia srl
// http://www.xmedia.net/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "defines.h"

int main(int argc, char *argv[]) {
	char *user, *domain, *dir;
	int retval;
	pid_t pid, ppid;

	if(argc < 3) {
		fprintf(stderr, "Usage: %s <user> <domain>\n", argv[0]);
		exit(1);
	}

	user = argv[1];
	domain = argv[2];

	if(! checkusername(user)) {
		fprintf(stderr, "Invalid user name %s\n", user);
		exit(EXIT_FAILURE); 
	}

	if(! checkdomainname(domain)) {
		fprintf(stderr, "Invalid domain name %s\n", domain);
		exit(EXIT_FAILURE);
	}

	if(! checkdomainowner(domain, user)) {
		fprintf(stderr, "Domain %s is not owned by user %s\n", domain, user);
		exit(EXIT_FAILURE);
	}

	dir = constructhomedir(domain);

	if(! checkhomedir(user, dir)) {
		fprintf(stderr, "Home directory mismatch! %s\n", dir);
		exit(EXIT_FAILURE);
	}

	pid = fork();
	if(pid == -1) {
		exit(EXIT_FAILURE);
	}

	if(pid == 0) {	// child
		// Remove user's home directory
		
		execle("/bin/rm", "/bin/rm", "-rf", constructhomedir(domain), NULL, NULL);
		// execle("/bin/ls", "/bin/ls", "-lR", constructhomedir(domain), NULL, NULL);
		return 0;
	}
	else {		// parent
		wait(NULL);
		retval = execle(USERDEL, USERDEL, user, NULL, NULL);
		// execle("/bin/echo", "/bin/echo", "-lR", NULL, NULL);
		return retval;
	}
}
