// This file is copyright 2000-2001 xmedia srl
// http://www.xmedia.net/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pwd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "defines.h"

/*
#ifdef VSETUP
#undef VSETUP
#endif
#define VSETUP "/home/httpd/html/php/c/pippo"
*/

int main(int argc, char *argv[]) {
	char *user, *domain, *dir;
	struct passwd *pwd;
	uid_t uid;
	gid_t gid;
	char *envp[2];
	char envstr[sizeof(MAILDIRBASE) + DOMAINSIZE + sizeof("HOME=") + 1];
	int retval;

	if(argc < 3) {
		fprintf(stderr, "Usage: %s <user> <domain>\n", argv[0]);
		exit(1);
	}

	user = argv[1];
	domain = argv[2];

	dir = constructhomedir(domain);
	if(! checkhomedir(user, dir)) {
		fprintf(stderr, "Invalid home directory %s\n", dir);
		exit(EXIT_FAILURE);
	}

	pwd = getpwnam(user);

	if(! pwd) {
		fprintf(stderr, "Unknown user %s\n", user);
		exit(EXIT_FAILURE);
	}

	uid = pwd->pw_uid;
	gid = pwd->pw_gid;
	dir = pwd->pw_dir;

	if((setgid(gid) == -1) || (setuid(uid) == -1) )
		die("setuid/setgid");

	snprintf(envstr, sizeof(envstr) - 1, "HOME=%s", dir);
	envp[0] = envstr;
	envp[1] = NULL;

	retval = execle(VSETUP, VSETUP, "--quiet", NULL, envp);
	if(retval == -1)
		die("execl");
}
