// This file is copyright 2000-2001 xmedia srl
// http://www.xmedia.net/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pwd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "defines.h"

int main(int argc, char *argv[]) {
	char *user, *domain;
	struct passwd *pwd;
	uid_t uid;
	gid_t gid;

	if(argc < 3) {
		fprintf(stderr, "Usage: %s <user> <domain>\n", argv[0]);
		exit(1);
	}

	user = argv[1];
	domain = argv[2];

	if(! checkusername(user)) {
		fprintf(stderr, "Invalid user name %s\n", user);
		exit(EXIT_FAILURE);
	}

	if(! checkdomainname(domain)) {
		fprintf(stderr, "Invalid domain name %s\n", domain);
		exit(EXIT_FAILURE);
	}

	if(! checkdomainowner(domain, user)) {
		fprintf(stderr, "Domain %s is not owned by user %s\n", domain, user);
		exit(EXIT_FAILURE);
	}

	pwd = getpwnam(user);

	if(! pwd) {
		fprintf(stderr, "Unknown user %s\n\n", user);
		exit(EXIT_FAILURE);
	}

	uid = pwd->pw_uid;
	gid = pwd->pw_gid;

	if(chroot(MAILDIRBASE) == -1)
		die("chroot");

	if(chdir("/") == -1)
		die("chdir");

	if(mkdir(domain, S_IRWXU) == -1)
		die("mkdir");

	if(chown(domain, uid, gid) == -1)
		rmdir(domain);
}
