// This file is copyright 2000-2001 xmedia srl
// http://www.xmedia.net/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <pwd.h>
#include <regex.h>
#include "defines.h"

void die(char *str) {
        perror(str);
        exit(EXIT_FAILURE);
}

int checkdomainowner(char *domain, char *owner) {
	char str[sizeof(COMMENTSTR) + DOMAINSIZE + 1];
	struct passwd *pwd;

	pwd = getpwnam(owner);
	if(! pwd)
		return 0;

	snprintf(str, sizeof(str) - 1, "%s%s\0", COMMENTSTR, domain);
	str[sizeof(str) - 1] = '\0';

	return(! strcmp(str, pwd->pw_gecos));
}

char *constructhomedir(char *domain) {
	static char dir[sizeof(MAILDIRBASE) + DOMAINSIZE + 2];

	snprintf(dir, sizeof(dir) - 1, "%s/%s\0", MAILDIRBASE, domain);
	dir[sizeof(dir) - 1] = '\0';
	return dir;
}

int checkhomedir(char *owner, char *homedir) {
	struct passwd *pwd;

	pwd = getpwnam(owner);
	if(! pwd)
		return 0;

	return(! strcmp(pwd->pw_dir, homedir));
}

int checkusername(char *name) {
	regex_t reg;

	if(strlen(name) > USERSIZE)
		return 0;

	if(regcomp(&reg, "[a-z0-9\\-]+", REG_NOSUB | REG_EXTENDED) != 0)
		return 0;

	return (regexec(&reg, name, 0, NULL, 0) == 0);
}

int checkdomainname(char *name) {
	regex_t reg;

	if(strlen(name) > DOMAINSIZE)
		return 0;

	if(regcomp(&reg, DOMAIN_REGEX, REG_NOSUB | REG_EXTENDED) != 0)
		return 0;

	return (regexec(&reg, name, 0, NULL, 0) == 0);
}
